import { ContextMenuItem } from '@/components/hive-context-menu/types';
import { VueComponent } from '../types/value';
import { ComponentPublicInstance } from 'vue';
export type Mount = (e: 'mount') => void;
export declare const onMount: (emit: Mount) => void;
export type Unmount = (e: 'unmount') => void;
export declare const onUnmount: (emit: Unmount) => void;
export type Focusout = (e: 'focusout') => void;
export declare const onFocusout: (emit: Focusout) => void;
export type Focusin = (e: 'focusin') => void;
export declare const onFocusin: (emit: Focusin) => void;
export type Keydown = (e: 'keydown', event: KeyboardEvent) => void;
export declare const onKeydown: (emit: Keydown, event: KeyboardEvent) => void;
export type Change<T> = (e: 'change', value: T) => void;
export declare const onChange: <T>(emit: Change<T>, value: T) => void;
export type ModelValueUpdated<T> = (e: 'model-value-updated', value: T) => void;
export type Update<T> = ((e: 'update:modelValue', value: T) => void) & ModelValueUpdated<T>;
export declare const onUpdateModelValue: <T>(emit: Update<T>, value: T) => void;
export type Click = (e: 'click', event: MouseEvent) => void;
export declare const onClick: (emit: Click, event: MouseEvent) => void;
export type Search<T> = (e: 'search', query: T) => void;
export declare const onSearch: <T>(emit: Search<T>, query: T) => void;
export type Input<T> = (e: 'input', value: T) => void;
export declare const onInput: <T>(emit: Input<T>, value: T) => void;
export type FileAdd = (e: 'fileAdd') => void;
export declare const onFileAdd: (emit: FileAdd) => void;
export type FileRemove = (e: 'fileRemove') => void;
export declare const onFileRemove: (emit: FileRemove) => void;
export type Close = (e: 'close') => void;
export declare const onClose: (emit: Close) => void;
export type BeforeEdit = (e: 'beforeEdit', value: unknown) => void;
export declare const onBeforeEdit: (emit: BeforeEdit, value: unknown) => void;
export type AfterEdit = (e: 'afterEdit', value: unknown) => void;
export declare const onAfterEdit: (emit: AfterEdit, value: unknown) => void;
export type BeforeChange = (e: 'beforeChange', value: unknown) => void;
export declare const onBeforeChange: (emit: BeforeChange, value: unknown) => void;
export type AfterChange = (e: 'afterChange', value: unknown) => void;
export declare const onAfterChange: (emit: AfterChange, value: unknown) => void;
export type Updated = (e: 'updated') => void;
export declare const onUpdated: (emit: Updated) => void;
export type Sort = (e: 'sort', value: string) => void;
export declare const onSort: (emit: Sort, value: string) => void;
export type QueryUpdate = (e: 'queryUpdate', value: string) => void;
export declare const onQueryUpdate: (emit: QueryUpdate, value: string) => void;
export type RowClick<T = ComponentPublicInstance> = (e: 'rowClick', row: Record<string, unknown>, rowRef: VueComponent<T> | null) => void;
export declare const onRowClick: <T = ComponentPublicInstance>(emit: RowClick<T>, row: Record<string, unknown>, rowRef: VueComponent<T> | null) => void;
export type DragStart<T> = (e: 'dragStart', value: T) => void;
export declare const onDragStart: <T>(emit: DragStart<T>, value: T) => void;
export type DragEnd<T> = (e: 'dragEnd', value: T) => void;
export declare const onDragEnd: <T>(emit: DragEnd<T>, value: T) => void;
export type NodeChoose<T> = (e: 'nodeChoose', value: T) => void;
export declare const onNodeChoose: <T>(emit: NodeChoose<T>, value: T) => void;
export type NodeCheck<T> = (e: 'nodeCheck', value: T, check: boolean) => void;
export declare const onNodeCheck: <T>(emit: NodeCheck<T>, value: T, check: boolean) => void;
export type NodeMounted<T> = (e: 'nodeMounted', value: T) => void;
export declare const onNodeMounted: <T>(emit: NodeMounted<T>, value: T) => void;
export type UpdateCheckedNodes<T> = (e: 'updateCheckedNodes', value: T) => void;
export declare const onUpdateCheckedNodes: <T>(emit: UpdateCheckedNodes<T>, value: T) => void;
export type ChildrenShow = (e: 'childrenShow', id: string, show: boolean) => void;
export declare const onChildrenShow: (emit: ChildrenShow, id: string, show: boolean) => void;
export type CloseContextMenu = (e: 'closeContextMenu') => void;
export declare const onCloseContextMenu: (emit: CloseContextMenu) => void;
export type ContextItemClick = (e: 'contextItemClick', item: ContextMenuItem) => void;
export declare const onContextItemClick: (emit: ContextItemClick, item: ContextMenuItem) => void;
export type UpdatePage = (e: 'update:page', page: number) => void;
export declare const onUpdatePage: (emit: UpdatePage, page: number) => void;
